#[macro_use] extern crate enum_primitive;
// Using macros from enum_primitive

use structopt::StructOpt;
use exitfailure::ExitFailure;
// Extern libraries

mod vm;
// Virtual machine module

#[derive(StructOpt)]
struct Cli {
	#[structopt(parse(from_os_str))]
	path: std::path::PathBuf,
}

fn main() -> Result<(), ExitFailure> {
	let args = Cli::from_args();
	let mut jBrain = vm::jBrainVM::new();

	let bytecode = match std::fs::read_to_string(args.path) {
		Err(error) => return Err(error.into()),
		Ok(bytecode) => bytecode,
	};

	println!("jBrain v{}", vm::jBrain_version());

	println!();
	
	jBrain.interpreter(bytecode);

	Ok(())
}
